<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!--NewPage-->
<HTML>
<HEAD>
<!-- Generated by javadoc (build 1.5.0_17) on Fri Dec 04 18:31:05 CET 2009 -->
<TITLE>
NAryOperator
</TITLE>

<META NAME="keywords" CONTENT="ch.javasoft.math.operator.NAryOperator interface">

<LINK REL ="stylesheet" TYPE="text/css" HREF="../../../../stylesheet.css" TITLE="Style">

<SCRIPT type="text/javascript">
function windowTitle()
{
    parent.document.title="NAryOperator";
}
</SCRIPT>
<NOSCRIPT>
</NOSCRIPT>

</HEAD>

<BODY BGCOLOR="white" onload="windowTitle();">


<!-- ========= START OF TOP NAVBAR ======= -->
<A NAME="navbar_top"><!-- --></A>
<A HREF="#skip-navbar_top" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_top_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="class-use/NAryOperator.html"><FONT CLASS="NavBarFont1"><B>Use</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../index-files/index-1.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../../ch/javasoft/math/operator/IntUnaryOperator.Id.html" title="enum in ch.javasoft.math.operator"><B>PREV CLASS</B></A>&nbsp;
&nbsp;<A HREF="../../../../ch/javasoft/math/operator/NullaryOperator.html" title="interface in ch.javasoft.math.operator"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../index.html?ch/javasoft/math/operator/NAryOperator.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="NAryOperator.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;FIELD&nbsp;|&nbsp;CONSTR&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;FIELD&nbsp;|&nbsp;CONSTR&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_top"></A>
<!-- ========= END OF TOP NAVBAR ========= -->

<HR>
<!-- ======== START OF CLASS DATA ======== -->
<H2>
<FONT SIZE="-1">
ch.javasoft.math.operator</FONT>
<BR>
Interface NAryOperator&lt;T,A&gt;</H2>
<DL>
<DT><B>All Known Subinterfaces:</B> <DD><A HREF="../../../../ch/javasoft/math/operator/BinaryOperator.html" title="interface in ch.javasoft.math.operator">BinaryOperator</A>&lt;T,A&gt;, <A HREF="../../../../ch/javasoft/math/operator/NullaryOperator.html" title="interface in ch.javasoft.math.operator">NullaryOperator</A>&lt;T,A&gt;, <A HREF="../../../../ch/javasoft/math/operator/QuaternaryOperator.html" title="interface in ch.javasoft.math.operator">QuaternaryOperator</A>&lt;T,A&gt;, <A HREF="../../../../ch/javasoft/math/operator/TernaryOperator.html" title="interface in ch.javasoft.math.operator">TernaryOperator</A>&lt;T,A&gt;, <A HREF="../../../../ch/javasoft/math/operator/UnaryOperator.html" title="interface in ch.javasoft.math.operator">UnaryOperator</A>&lt;T,A&gt;</DD>
</DL>
<DL>
<DT><B>All Known Implementing Classes:</B> <DD><A HREF="../../../../ch/javasoft/math/operator/AbstractBinaryOperator.html" title="class in ch.javasoft.math.operator">AbstractBinaryOperator</A>, <A HREF="../../../../ch/javasoft/math/operator/AbstractNullaryOperator.html" title="class in ch.javasoft.math.operator">AbstractNullaryOperator</A>, <A HREF="../../../../ch/javasoft/math/operator/AbstractQuaternaryOperator.html" title="class in ch.javasoft.math.operator">AbstractQuaternaryOperator</A>, <A HREF="../../../../ch/javasoft/math/operator/AbstractTernaryOperator.html" title="class in ch.javasoft.math.operator">AbstractTernaryOperator</A>, <A HREF="../../../../ch/javasoft/math/operator/AbstractUnaryOperator.html" title="class in ch.javasoft.math.operator">AbstractUnaryOperator</A>, <A HREF="../../../../ch/javasoft/math/operator/compose/BinaryBinaryOperator.html" title="class in ch.javasoft.math.operator.compose">BinaryBinaryOperator</A>, <A HREF="../../../../ch/javasoft/math/operator/compose/BinaryNullaryOperator.html" title="class in ch.javasoft.math.operator.compose">BinaryNullaryOperator</A>, <A HREF="../../../../ch/javasoft/math/operator/compose/BinaryUnaryOperator.html" title="class in ch.javasoft.math.operator.compose">BinaryUnaryOperator</A>, <A HREF="../../../../ch/javasoft/math/operator/compose/ConcatBinaryOperator.html" title="class in ch.javasoft.math.operator.compose">ConcatBinaryOperator</A>, <A HREF="../../../../ch/javasoft/math/operator/compose/ConcatNAryOperator.html" title="class in ch.javasoft.math.operator.compose">ConcatNAryOperator</A>, <A HREF="../../../../ch/javasoft/math/operator/compose/ConcatNullaryOperator.html" title="class in ch.javasoft.math.operator.compose">ConcatNullaryOperator</A>, <A HREF="../../../../ch/javasoft/math/operator/compose/ConcatQuaternaryOperator.html" title="class in ch.javasoft.math.operator.compose">ConcatQuaternaryOperator</A>, <A HREF="../../../../ch/javasoft/math/operator/compose/ConcatTernaryOperator.html" title="class in ch.javasoft.math.operator.compose">ConcatTernaryOperator</A>, <A HREF="../../../../ch/javasoft/math/operator/compose/ConcatUnaryOperator.html" title="class in ch.javasoft.math.operator.compose">ConcatUnaryOperator</A>, <A HREF="../../../../ch/javasoft/math/operator/compose/NAryNAryOperator.html" title="class in ch.javasoft.math.operator.compose">NAryNAryOperator</A>, <A HREF="../../../../ch/javasoft/math/operator/compose/NullaryBinaryOperator.html" title="class in ch.javasoft.math.operator.compose">NullaryBinaryOperator</A>, <A HREF="../../../../ch/javasoft/math/operator/compose/NullaryNullaryOperator.html" title="class in ch.javasoft.math.operator.compose">NullaryNullaryOperator</A>, <A HREF="../../../../ch/javasoft/math/operator/compose/NullaryQuaternaryOperator.html" title="class in ch.javasoft.math.operator.compose">NullaryQuaternaryOperator</A>, <A HREF="../../../../ch/javasoft/math/operator/compose/NullaryTernaryOperator.html" title="class in ch.javasoft.math.operator.compose">NullaryTernaryOperator</A>, <A HREF="../../../../ch/javasoft/math/operator/compose/NullaryUnaryOperator.html" title="class in ch.javasoft.math.operator.compose">NullaryUnaryOperator</A>, <A HREF="../../../../ch/javasoft/math/operator/compose/QuaternaryNullaryOperator.html" title="class in ch.javasoft.math.operator.compose">QuaternaryNullaryOperator</A>, <A HREF="../../../../ch/javasoft/math/operator/compose/TernaryNullaryOperator.html" title="class in ch.javasoft.math.operator.compose">TernaryNullaryOperator</A>, <A HREF="../../../../ch/javasoft/math/operator/compose/TernaryUnaryOperator.html" title="class in ch.javasoft.math.operator.compose">TernaryUnaryOperator</A>, <A HREF="../../../../ch/javasoft/math/operator/compose/UnaryBinaryOperator.html" title="class in ch.javasoft.math.operator.compose">UnaryBinaryOperator</A>, <A HREF="../../../../ch/javasoft/math/operator/compose/UnaryNullaryOperator.html" title="class in ch.javasoft.math.operator.compose">UnaryNullaryOperator</A>, <A HREF="../../../../ch/javasoft/math/operator/compose/UnaryTernaryOperator.html" title="class in ch.javasoft.math.operator.compose">UnaryTernaryOperator</A>, <A HREF="../../../../ch/javasoft/math/operator/compose/UnaryUnaryOperator.html" title="class in ch.javasoft.math.operator.compose">UnaryUnaryOperator</A></DD>
</DL>
<HR>
<DL>
<DT><PRE>public interface <A HREF="../../../../src-html/ch/javasoft/math/operator/NAryOperator.html#line.45"><B>NAryOperator&lt;T,A&gt;</B></A></DL>
</PRE>

<P>
The <code>NAryOperator</code> performs an operation on <code>n</code> many 
 operands, where <code>n</code> is a fixed number. N-ary operators typically arise 
 from concatenation of several <A HREF="../../../../ch/javasoft/math/operator/BinaryOperator.html" title="interface in ch.javasoft.math.operator"><CODE>binary</CODE></A> and 
 <A HREF="../../../../ch/javasoft/math/operator/UnaryOperator.html" title="interface in ch.javasoft.math.operator"><CODE>unary</CODE></A> operators.
<P>

<P>
<HR>

<P>

<!-- ========== METHOD SUMMARY =========== -->

<A NAME="method_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Method Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/operator/NAryOperator.html#getOperandCount()">getOperandCount</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;The number of operands, that is, the <code>"n"</code> for this n-ary operation</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/operator/NAryOperator.html#operate(int, A[], int[], A, int)">operate</A></B>(int&nbsp;offset,
               <A HREF="../../../../ch/javasoft/math/operator/NAryOperator.html" title="type parameter in NAryOperator">A</A>[]&nbsp;operands,
               int[]&nbsp;indices,
               <A HREF="../../../../ch/javasoft/math/operator/NAryOperator.html" title="type parameter in NAryOperator">A</A>&nbsp;dst,
               int&nbsp;dstIndex)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Performs the binary operation &oplus; on two vector elements, also 
 writing the result back into a vector:</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../ch/javasoft/math/operator/NAryOperator.html" title="type parameter in NAryOperator">T</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../ch/javasoft/math/operator/NAryOperator.html#operate(int, T...)">operate</A></B>(int&nbsp;offset,
               <A HREF="../../../../ch/javasoft/math/operator/NAryOperator.html" title="type parameter in NAryOperator">T</A>...&nbsp;operands)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Performs the binary operation &oplus; on two operands and returns the 
 result:</TD>
</TR>
</TABLE>
&nbsp;
<P>

<!-- ============ METHOD DETAIL ========== -->

<A NAME="method_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Method Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="getOperandCount()"><!-- --></A><H3>
getOperandCount</H3>
<PRE>
int <A HREF="../../../../src-html/ch/javasoft/math/operator/NAryOperator.html#line.50"><B>getOperandCount</B></A>()</PRE>
<DL>
<DD>The number of operands, that is, the <code>"n"</code> for this n-ary operation
<P>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="operate(int,java.lang.Object)"><!-- --></A><A NAME="operate(int, T...)"><!-- --></A><H3>
operate</H3>
<PRE>
<A HREF="../../../../ch/javasoft/math/operator/NAryOperator.html" title="type parameter in NAryOperator">T</A> <A HREF="../../../../src-html/ch/javasoft/math/operator/NAryOperator.html#line.62"><B>operate</B></A>(int&nbsp;offset,
          <A HREF="../../../../ch/javasoft/math/operator/NAryOperator.html" title="type parameter in NAryOperator">T</A>...&nbsp;operands)</PRE>
<DL>
<DD>Performs the binary operation &oplus; on two operands and returns the 
 result:
 <pre>
   return = &oplus; ( operands )
 </pre>
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>offset</CODE> - the offset for the first operand in <code>operands</code><DD><CODE>operands</CODE> - the <A HREF="../../../../ch/javasoft/math/operator/NAryOperator.html#getOperandCount()"><CODE>n</CODE></A> operands
<DT><B>Returns:</B><DD>the result of the n-ary operation</DL>
</DD>
</DL>
<HR>

<A NAME="operate(int,java.lang.Object,int,java.lang.Object,int)"><!-- --></A><A NAME="operate(int, A[], int[], A, int)"><!-- --></A><H3>
operate</H3>
<PRE>
void <A HREF="../../../../src-html/ch/javasoft/math/operator/NAryOperator.html#line.78"><B>operate</B></A>(int&nbsp;offset,
             <A HREF="../../../../ch/javasoft/math/operator/NAryOperator.html" title="type parameter in NAryOperator">A</A>[]&nbsp;operands,
             int[]&nbsp;indices,
             <A HREF="../../../../ch/javasoft/math/operator/NAryOperator.html" title="type parameter in NAryOperator">A</A>&nbsp;dst,
             int&nbsp;dstIndex)</PRE>
<DL>
<DD>Performs the binary operation &oplus; on two vector elements, also 
 writing the result back into a vector:
 <pre>
   dst[dstIndex] = &oplus; ( operands[indices] )
 </pre>
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>offset</CODE> - the offset for the first operand in <code>operands</code> and 
                                        <code>indices</code><DD><CODE>operands</CODE> - the <A HREF="../../../../ch/javasoft/math/operator/NAryOperator.html#getOperandCount()"><CODE>n</CODE></A> operand arrays<DD><CODE>indices</CODE> - the indices in the operand arrays<DD><CODE>dst</CODE> - the result array<DD><CODE>dstIndex</CODE> - the index in the result array</DL>
</DD>
</DL>
<!-- ========= END OF CLASS DATA ========= -->
<HR>


<!-- ======= START OF BOTTOM NAVBAR ====== -->
<A NAME="navbar_bottom"><!-- --></A>
<A HREF="#skip-navbar_bottom" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_bottom_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="class-use/NAryOperator.html"><FONT CLASS="NavBarFont1"><B>Use</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../index-files/index-1.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../../ch/javasoft/math/operator/IntUnaryOperator.Id.html" title="enum in ch.javasoft.math.operator"><B>PREV CLASS</B></A>&nbsp;
&nbsp;<A HREF="../../../../ch/javasoft/math/operator/NullaryOperator.html" title="interface in ch.javasoft.math.operator"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../index.html?ch/javasoft/math/operator/NAryOperator.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="NAryOperator.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;FIELD&nbsp;|&nbsp;CONSTR&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;FIELD&nbsp;|&nbsp;CONSTR&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_bottom"></A>
<!-- ======== END OF BOTTOM NAVBAR ======= -->

<HR>

</BODY>
</HTML>
